// Globals

 var height = 0;
 var width = 0;
 var myButton;
 var myInfo;
 var myPicData = "";
 var loadingMessage = "<h1>MBS</h1><h2>Schedule</h2><h4>Loading data ...</h4>";
 var noInternetMessage = "<h1>MBS</h1><h2>Schedule</h2><h4>Check connection ...</h4>";
 var myToday;
 var myTomorrow;
 var dayWord;
 var picDay = "today";
 var picDiv = "US";
 var divToShow = "US";
 var todayImgFile = "";
 var tomorrowImgFile = "";
 var todayFile;
 var tomorrowFile;
 
/* Unique identifier for multiple instances which will retain prefs 
  * between logins.                                                              
  */

if ( window.widget )
{
	//widget.onshow = setup;
}

function makeKey(key)
{
	return widget.identifier + "-" + key;
}

function setup()
{
	showLoadingMessage(); // Sets loading message
	setBackPrefPanel();	
	setLinks();
	myButton = new AppleGlassButton( document.getElementById("myAppleButton"), "Done", hidePrefs );
	myAppleButton.style.display="none";
	myInfo = new AppleInfoButton( document.getElementById("myInfoButton"), document.getElementById("front"), "white", "white", showPrefs);
	
	setInterval( 'getPreferences()', 1000);
}

function showLoadingMessage()
{
	document.getElementById("myPicture").innerHTML = loadingMessage;
}

function showNoInternetMessage()
{
	document.getElementById("myPicture").innerHTML = noInternetMessage;
}


writePicData = function(obj )
{
	myPicData = obj.outputString;
	if ( ! myPicData )
	{
		showNoInternetMessage();
		
	} else {
		document.getElementById("myPicture").innerHTML = myPicData;
	}
}

function getPreferences()
{    
/* Grab preferences */
	picDay = widget.preferenceForKey(widget.identifier + "-whichDay");
	
	if ( picDay && picDay.length > 0 )
	{
		if ( picDay == "today" )
		{
			dayWord = "TODAY";	
		}
			
		if ( picDay == "tomorrow" )
		{
			dayWord = "TOMORROW";
		}
	}
	else 
	{
		widget.setPreferenceForKey("today", makeKey("whichDay"));
		dayWord = "TODAY";
	}
		
		
	picDiv = widget.preferenceForKey(widget.identifier + "-whichDiv");
	
	if ( picDiv && picDiv.length > 0)
	 	divToShow = picDiv.toUpperCase();
	 else {
	 	widget.setPreferenceForKey("us", makeKey("whichDv"));
	 	divToShow = 'US';
	 }	
	 
	

	setTimeout(getPicData(),1000);	

}

function getPicData()
{
	
	 
	if ( dayWord == "TODAY" && divToShow == 'US' ) {
		cmd = "/usr/bin/curl 'https://campus.mbs.net/mbs/curriculum/ajaxWidget.php?day=TODAY&div=US'";
	} else if ( dayWord == "TODAY" && divToShow == 'MS' )  {
		cmd = "/usr/bin/curl 'https://campus.mbs.net/mbs/curriculum/ajaxWidget.php?day=TODAY&div=MS'";
	} else if ( dayWord == "TOMORROW" && divToShow == 'US' )  {
		cmd = "/usr/bin/curl 'https://campus.mbs.net/mbs/curriculum/ajaxWidget.php?day=TOMORROW&div=US'";
	} else {
		cmd = "/usr/bin/curl 'https://campus.mbs.net/mbs/curriculum/ajaxWidget.php?day=TOMORROW&div=MS'";
	}
	
	widget.system(cmd, writePicData);

}

function setBackPrefPanel()
{
	document.getElementById("prefBox").innerHTML = "Choose Division:<br /><select id='divPopup' onchange='changeDivision(this);'>" + 
	"<option value=0></option><option value=1>Upper School</option><option value=2>Middle School</option></select><br />" + 
	"Choose Day:<br /><select id='dayPopup' onchange='changeDay(this);'><option value=0></option>" + 
	"<option value=1>Today</option><option value=2>Tomorrow</option></select>";	
}

function setLinks()
{
	document.getElementById("weekLinks").innerHTML = '<a href="javascript:showSched()">See Full Schedule</a><br />';
}

function showSched()
{
	if ( widget)
		widget.openURL('https://campus.mbs.net/mbs/widget/week.html');
}

function showPrefs()
{
	var front = document.getElementById("front");		
	var back = document.getElementById("back");		
	
	
	
	if(window.widget)									
		widget.prepareForTransition("ToBack");		
	
	front.style.display="none";							
	back.style.display="block";	
	setPrefSpinners();					
	myAppleButton.style.display="block";
	
	if(window.widget)									
		setTimeout ('widget.performTransition();', 0);	
													
}

function setPrefSpinners() {
	picDay = widget.preferenceForKey(widget.identifier + "-whichDay");
	picDiv = widget.preferenceForKey(widget.identifier + "-whichDiv");
	
	
	 if (picDiv && picDiv == 'ms') {
	 	document.getElementById('divPopup').selectedIndex = "2";
	 } else {
	 	document.getElementById('divPopup').selectedIndex = "1";
	 }
	
	if (picDay && picDay == 'today') {
		document.getElementById('dayPopup').selectedIndex = "1";
		
	} else {
	 	document.getElementById('dayPopup').selectedIndex = "2";
	 }
	
	
	
}

function hidePrefs()
{
																
	changeDay( dayPopup );
	changeDivision( divPopup );

	var front = document.getElementById("front");		
	var back = document.getElementById("back");		
	
	if (window.widget)									
		widget.prepareForTransition("ToFront");		
	
	front.style.display="block";	
					
	back.style.display="none";					
	
	setTimeout( "getPreferences()", 2000);
	
	if (window.widget)									
		setTimeout ('widget.performTransition();', 0);
}													







/* Animate preferences button */

var flipShown = false;

/* Structure that holds information that is needed for the animation to run. */
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, secondElement:null, timer:""};

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

/* animate() performs the fade animation for the preferences flipper */
function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


function mousemove (event)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('myInfoButton');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('myInfoButton');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


function changeDivision(elem)
{	
	var divisonName = "";
		
	switch( parseInt(elem.options[elem.selectedIndex].value) )
	{
		case 0: 
			divisionName = widget.preferenceForKey(widget.identifier + "-whichDiv");
			if ( !( divisionName && divisionName.length > 0 ) )
				divisionName = "us";
			break;
		case 1:								
			divisonName = "us";
			break;
		case 2:								
			divisonName = "ms";
			break;
	}
	if ( window.widget)
	{
		widget.setPreferenceForKey(divisonName, makeKey("whichDiv"));	
	}
} 

function changeDay(elem)
{	
	var dayName = "";
	switch( parseInt(elem.options[elem.selectedIndex].value) )
	{
		case 0: 
			dayName = widget.preferenceForKey(widget.identifier + "-whichDay");
			if ( !( dayName && dayName.length > 0 ) )
			{
				dayName = "today";
			}	
			break;
		case 1:								
			dayName = "today";
			break;
		case 2:								
			dayName = "tomorrow";
			break;
	}
	if ( window.widget)
	{
		widget.setPreferenceForKey(dayName, makeKey("whichDay"));	
	}
} 


/* clears away any preferences that this widget may have had */

function onremove()
{
		widget.setPreferenceForKey(undefined,makeKey("whichDay"));
		widget.setPreferenceForKey(undefined,makeKey("whichDiv"));

}


if(window.widget)
{
	widget.onremove = onremove;
}